BaseCharFilter (Lucene 10.5.1 common API)
Description: declaration: package: org.apache.lucene.analysis.charfilter, class: BaseCharFilter

Package org.apache.lucene.analysis.charfilter

# Class BaseCharFilter

java.lang.Object
java.io.Reader
org.apache.lucene.analysis.CharFilter
org.apache.lucene.analysis.charfilter.BaseCharFilter

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`, `Readable`

Direct Known Subclasses:
  `CJKWidthCharFilter`, `HTMLStripCharFilter`, `MappingCharFilter`, `PatternReplaceCharFilter`

public abstract class BaseCharFilter extends CharFilter
Base utility class for implementing a `CharFilter`. You subclass this, and then record mappings by calling `addOffCorrectMap(int, int)`, and then invoke the correct method to correct an offset.

- ## Field Summary

  ### Fields inherited from class org.apache.lucene.analysis.CharFilter

  `input`

  ### Fields inherited from class java.io.Reader

  `lock`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BaseCharFilter(Reader in)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected void`
  `addOffCorrectMap(int off, int cumulativeDiff)`
  Adds an offset correction mapping at the given output stream offset.
  `protected int`
  `correct(int currentOff)`
  Retrieve the corrected offset.
  `protected int`
  `getLastCumulativeDiff()`

  ### Methods inherited from class org.apache.lucene.analysis.CharFilter

  `close, correctOffset`

  ### Methods inherited from class java.io.Reader

  `mark, markSupported, nullReader, read, read, read, read, ready, reset, skip, transferTo`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### BaseCharFilter

    public BaseCharFilter(Reader in)

- ## Method Details

  - ### correct

    protected int correct(int currentOff)
    Retrieve the corrected offset.
    Specified by:
      `correct` in class `CharFilter`

  - ### getLastCumulativeDiff

    protected int getLastCumulativeDiff()

  - ### addOffCorrectMap

    protected void addOffCorrectMap(int off, int cumulativeDiff)
    Adds an offset correction mapping at the given output stream offset.

    Assumption: the offset given with each successive call to this method will not be smaller than the offset given at the previous invocation.

    Parameters:
      `off` - The output stream offset at which to apply the correction
      `cumulativeDiff` - The input offset is given by adding this to the output offset